- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.NodeTemplateAggregatedList.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.NodeTemplateAggregatedList.SCHEMA_REPRESENTATION.item.map_entry1.value.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.NodeTemplateAggregatedList.SCHEMA_REPRESENTATION.item.map_entry1.value.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.NodeTemplateAggregatedList.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/v1/nodeTemplates/aggregatedList#try-it)

Retrieves an aggregated list of node templates.

To prevent failure, Google recommends that you set the `returnPartialSuccess` parameter to `true`.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/v1/projects/{project}/aggregated/nodeTemplates`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |
| `includeAllScopes` | `boolean` Indicates whether every visible scope for each scope type (zone, region, global) should be included in the response. For new resource types added after this field, the flag has no effect as new resource types will always include every visible scope for each scope type in response. For resource types which predate this field, if this flag is omitted or false, only scopes of the scope types where the resource type is expected to be found will be included. |
| `serviceProjectNumber` | `string (https://developers.google.com/discovery/v1/type-format format)` The Shared VPC service project id or service project number for which aggregated list request is invoked for subnetworks list-usable api. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "items": { string: { "nodeTemplates": [ { "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "nodeType": string, "nodeAffinityLabels": { string: string, ... }, "status": enum, "statusMessage": string, "region": string, "selfLink": string, "nodeTypeFlexibility": { "cpus": string, "memory": string, "localSsd": string }, "serverBinding": { "type": enum }, "disks": [ { "diskType": string, "diskSizeGb": integer, "diskCount": integer } ], "accelerators": [ { "acceleratorType": string, "acceleratorCount": integer } ], "cpuOvercommitType": enum } ], "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } }, ... }, "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] }, "unreachables": [ string ] } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of resource.Always `compute#nodeTemplateAggregatedList` for aggregated lists of node templates. |
| `id` | `string` Output only. Unique identifier for the resource; defined by the server. |
| `items` | `map (key: string, value: object)` A list of NodeTemplatesScopedList resources. **Key:** Output only. Name of the scope containing this set of node templates. |
| `items.nodeTemplates[]` | `object` Output only. A list of node templates contained in this scope. |
| `items.nodeTemplates[].kind` | `string` Output only. The type of the resource. Always `compute#nodeTemplate` for node templates. |
| `items.nodeTemplates[].id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `items.nodeTemplates[].creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `items.nodeTemplates[].name` | `string` The name of the resource, provided by the client when initially creating the resource. The resource name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `items.nodeTemplates[].description` | `string` An optional description of this resource. Provide this property when you create the resource. |
| `items.nodeTemplates[].nodeType` | `string` The node type to use for nodes group that are created from this template. |
| `items.nodeTemplates[].nodeAffinityLabels` | `map (key: string, value: string)` Labels to use for node affinity, which will be used in instance scheduling. |
| `items.nodeTemplates[].status` | `enum` Output only. The status of the node template. One of the following values: `CREATING`, `READY`, and `DELETING`. |
| `items.nodeTemplates[].statusMessage` | `string` Output only. An optional, human-readable explanation of the status. |
| `items.nodeTemplates[].region` | `string` Output only. The name of the region where the node template resides, such as us-central1. |
| `items.nodeTemplates[].selfLink` | `string` Output only. Server-defined URL for the resource. |
| `items.nodeTemplates[].nodeTypeFlexibility` | `object` Do not use. Instead, use the `nodeType` property. |
| `items.nodeTemplates[].nodeTypeFlexibility.cpus` | `string` |
| `items.nodeTemplates[].nodeTypeFlexibility.memory` | `string` |
| `items.nodeTemplates[].nodeTypeFlexibility.localSsd` | `string` |
| `items.nodeTemplates[].serverBinding` | `object` Sets the binding properties for the physical server. Valid values include: - **\[Default\]** `RESTART_NODE_ON_ANY_SERVER`: Restarts VMs on any available physical server - `RESTART_NODE_ON_MINIMAL_SERVER`: Restarts VMs on the same physical server whenever possible <br /> See [Sole-tenant node options](https://docs.cloud.google.com/compute/docs/nodes/create-nodes#sole-tenant_node_options) for more information. |
| `items.nodeTemplates[].serverBinding.type` | `enum` |
| `items.nodeTemplates[].disks[]` | `object` |
| `items.nodeTemplates[].disks[].diskType` | `string` Specifies the desired disk type on the node. This disk type must be a local storage type (e.g.: `local-ssd`). Note that for nodeTemplates, this should be the name of the disk type and not its URL. |
| `items.nodeTemplates[].disks[].diskSizeGb` | `integer` Specifies the size of the disk in base-2 GB. |
| `items.nodeTemplates[].disks[].diskCount` | `integer` Specifies the number of such disks. |
| `items.nodeTemplates[].accelerators[]` | `object` |
| `items.nodeTemplates[].accelerators[].acceleratorType` | `string` Full or partial URL of the accelerator type resource to attach to this instance. For example: `projects/my-project/zones/us-central1-c/acceleratorTypes/nvidia-tesla-p100` If you are creating an instance template, specify only the accelerator name. See [GPUs on Compute Engine](https://docs.cloud.google.com/compute/docs/gpus#introduction) for a full list of accelerator types. |
| `items.nodeTemplates[].accelerators[].acceleratorCount` | `integer` The number of the guest accelerator cards exposed to this instance. |
| `items.nodeTemplates[].cpuOvercommitType` | `enum` CPU overcommit. |
| `items.warning` | `object` Output only. An informational warning that appears when the node templates list is empty. |
| `items.warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `items.warning.message` | `string` Output only. A human-readable description of the warning code. |
| `items.warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `items.warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `items.warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `selfLink` | `string` Output only. Server-defined URL for this resource. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `unreachables[]` | `string` Output only. Unreachable resources. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.nodeTemplates.list`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).